Summary: Courier-IMAP server
Name: courier-imap
Version: 3.0.8
Release: 13tr
License: GPL
Group: Trustix Official
Source: http://unc.dl.sourceforge.net/sourceforge/courier/courier-imap-%{version}.tar.bz2
Source1: courier-imapd.init
Source2: courier-pop3d.init
Source3: courier-simapd.init
Source4: courier-pop3sd.init
Source5: courier-imapd.conf
Source6: courier-pop3d.conf
Source7: courier-simapd.conf
Source8: courier-pop3sd.conf
Source10: courier-imap-authdaemonrc
Source11: courier-imap-authldaprc
Source12: courier-imap-authmysqlrc
Source13: courier-imap-authpgsqlrc
Patch0: courier-imap-mksslcert.patch
Patch1: courier-imap-mkimapdcert.patch
URL: http://www.courier-mta.org
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: chkconfig, coreutils, sed
Requires: tsl-utils, db4, openssl, imapd-pam
BuildRequires: coreutils, rpm >= 4.0.2, sed, gcc-c++-devel
BuildRequires: perl, db4-devel, openssl-devel
BuildRequires: pam-devel openldap-devel mysql-devel postgresql-devel
Provides: imapd

%define almostauthdaemondir /var/spool/authdaemon
%define authdaemondir %{almostauthdaemondir}/courier-imap
%define sslcachedir /var/spool/courier
%define sslcache %{sslcachedir}/sslcache

%description
Courier-IMAP is an IMAP server for Maildir mailboxes.  This package contains
the standalone version of the IMAP server that's included in the Courier
mail server package.  This package is a standalone version for use with
other mail servers.

%package ldap
Summary: Courier-IMAP LDAP authentication driver.
Group: Trustix Official
Requires: %{name} = %{version}
Requires: openldap-libs

%description ldap
This package contains the necessary files to allow Courier-IMAP to
authenticate from an LDAP directory.  Install this package if you need
the ability to use an LDAP directory for authentication.

%package mysql
Summary: Courier-IMAP MySQL authentication driver.
Group: Trustix Official
Requires: %{name} = %{version}
Requires: mysql-libs

%description mysql
This package contains the necessary files to allow Courier-IMAP to
authenticate using a MySQL database table.  Install this package if you need
the ability to use a MySQL database table for authentication.

%package pgsql
Summary: Courier-IMAP PostgreSQL authentication driver.
Group: Trustix Official
Requires: %{name} = %{version}
Requires: postgresql-libs

%description pgsql
This package contains the necessary files to allow Courier-IMAP to
authenticate using a PostgreSQL database table.  Install this package if you
need the ability to use a PostgreSQL database table for authentication.


%package authtest
Summary: Test the Courier Authentication Library.
Group: Trustix Official
Requires: %{name} = %{version}
Requires: postgresql-libs mysql-libs 

%description authtest
authtest is a command-line diagnostic utility for the Courier
Authentication Library.


%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
CFLAGS="`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g'` -fexceptions" \
        CXXFLAGS="`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g'` -fexceptions" \
        XCFLAGS="`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g'` -fexceptions" \
        TCFLAGS="`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g'` -fexceptions" \
	   ./configure --prefix=%{_prefix} \
	   --mandir=%{_mandir} \
	   --localstatedir=%{_localstatedir} \
           --with-authdaemonvar=%{authdaemondir} \
           --enable-unicode \
           --with-db=db \
           --disable-root-check \
           --sysconfdir=%{_sysconfdir}/%{name} \
           --libexecdir=%{_prefix}/%{_lib}/%{name} \
           --datadir=%{_datadir}/%{name} \
           --with-piddir=/var/run

make

%install
[ -n "$RPM_BUILD_ROOT" -a "RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_initdir}
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/%{name}
make install-strip DESTDIR=$RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT/%{sslcachedir}

install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_initdir}/courier-imapd
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_initdir}/courier-pop3d
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{_initdir}/courier-simapd
install -m 755 %{SOURCE4} $RPM_BUILD_ROOT%{_initdir}/courier-pop3sd

install -m 600 %{SOURCE10} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/authdaemonrc
install -m 600 %{SOURCE11} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/authldaprc
install -m 600 %{SOURCE12} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/authmysqlrc
install -m 600 %{SOURCE13} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/authpgsqlrc


install -d -m 700 $RPM_BUILD_ROOT/%{authdaemondir}/
install -m 600 /dev/null $RPM_BUILD_ROOT/%{authdaemondir}/lock
install -m 600 /dev/null $RPM_BUILD_ROOT/%{authdaemondir}/pid
authlib/authmksock $RPM_BUILD_ROOT/%{authdaemondir}/socket
chmod 777 $RPM_BUILD_ROOT/%{authdaemondir}/socket

mkdir -p $RPM_BUILD_ROOT/etc/openldap/schema
install -m 444 authlib/authldap.schema \
    $RPM_BUILD_ROOT/etc/openldap/schema/courier.schema

mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/run
install %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/imapd
install %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/pop3d
install %{SOURCE7} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/imapd-ssl
install %{SOURCE8} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/pop3d-ssl
for i in authdaemonrc imapd imapd-ssl pop3d pop3d-ssl ; do
    touch $RPM_BUILD_ROOT%{_localstatedir}/run/${i}.pid
    touch $RPM_BUILD_ROOT%{_localstatedir}/run/${i}.pid.lock
    chmod 600 $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/$i
done

# Install authtest
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
install -m 755 $RPM_BUILD_DIR/%{name}-%{version}/authlib/authtest $RPM_BUILD_ROOT%{_sbindir}/authtest


# fix the document names
cp imap/README README.imap
cp maildir/README.maildirquota.txt README.maildirquota
cp maildir/README.sharedfolders.txt README.sharedfolders


%post
/sbin/chkconfig --add courier-imapd
/sbin/chkconfig --add courier-simapd
/sbin/chkconfig --add courier-pop3d
/sbin/chkconfig --add courier-pop3sd
if [ $1 = 2 ]; then
	/sbin/restart_maybe courier-imapd
	/sbin/restart_maybe courier-simapd
	/sbin/restart_maybe courier-pop3d
	/sbin/restart_maybe courier-pop3sd
fi

%preun
if [ "$1" = "0" ] ; then
    /sbin/service courier-imapd status > /dev/null
    if [ "$?" = "0" ]; then
	    /sbin/service courier-imapd stop
    fi
    /sbin/service courier-simapd status > /dev/null
    if [ "$?" = "0" ]; then
	    /sbin/service courier-simapd stop
    fi
    /sbin/service courier-pop3d status > /dev/null
    if [ "$?" = "0" ]; then
	    /sbin/service courier-pop3d stop
    fi
    /sbin/service courier-pop3sd status > /dev/null
    if [ "$?" = "0" ]; then
	    /sbin/service courier-pop3sd stop
    fi
    rm -f %{sslcache}
    /sbin/chkconfig --del courier-imapd
    /sbin/chkconfig --del courier-simapd
    /sbin/chkconfig --del courier-pop3d
    /sbin/chkconfig --del courier-pop3sd
fi


%clean
[ -n "$RPM_BUILD_ROOT" -a "RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,0755)
%doc AUTHORS COPYING imap/BUGS README README.imap README.maildirquota
%doc imap/FAQ imap/FAQ.html README.sharedfolders authlib/README.*
%doc INSTALL

%{_initdir}/*

%dir    %{_sysconfdir}/%{name}
%config(noreplace)  %{_sysconfdir}/%{name}/imapd
%config(noreplace)  %{_sysconfdir}/%{name}/imapd.cnf
%config(noreplace)  %{_sysconfdir}/%{name}/imapd-ssl
%config(noreplace)  %{_sysconfdir}/%{name}/pop3d
%config(noreplace)  %{_sysconfdir}/%{name}/pop3d.cnf
%config(noreplace)  %{_sysconfdir}/%{name}/pop3d-ssl
%config(noreplace) %{_sysconfdir}/%{name}/quotawarnmsg.example
%config(noreplace) %{_sysconfdir}/%{name}/authdaemonrc

%dir    %{_sysconfdir}/%{name}/shared
%dir    %{_sysconfdir}/%{name}/shared.tmp
        %{_bindir}/*
/usr/sbin/authenumerate
/usr/sbin/courierlogger
/usr/sbin/imaplogin
/usr/sbin/makeuserdb
/usr/sbin/mkimapdcert
/usr/sbin/mkpop3dcert
/usr/sbin/pop3login
/usr/sbin/pw2userdb
/usr/sbin/sharedindexinstall
/usr/sbin/sharedindexsplit
/usr/sbin/userdb
/usr/sbin/userdbpw
/usr/sbin/vchkpw2userdb


%dir    %{_datadir}/%{name}
        %{_datadir}/%{name}/makeuserdb
        %{_datadir}/%{name}/mkimapdcert
        %{_datadir}/%{name}/mkpop3dcert
        %{_datadir}/%{name}/pw2userdb
        %{_datadir}/%{name}/userdb
        %{_datadir}/%{name}/vchkpw2userdb
%dir    %{_prefix}/%{_lib}/%{name}
        %{_prefix}/%{_lib}/%{name}/imapd.rc
        %{_prefix}/%{_lib}/%{name}/makedatprog
        %{_prefix}/%{_lib}/%{name}/couriertcpd
        %{_prefix}/%{_lib}/%{name}/imapd-ssl.rc
        %{_prefix}/%{_lib}/%{name}/pop3d.rc
        %{_prefix}/%{_lib}/%{name}/pop3d-ssl.rc

%ghost  /var/run/*.pid
%ghost  /var/run/*.lock

%dir    %{_prefix}/%{_lib}/%{name}/authlib
        %{_prefix}/%{_lib}/%{name}/authlib/authdaemon
        %{_prefix}/%{_lib}/%{name}/authlib/authdaemond
        %{_prefix}/%{_lib}/%{name}/authlib/authdaemond.plain
%dir	%{almostauthdaemondir}
%dir    %{authdaemondir}
%dir    %{sslcachedir}
%ghost  %{authdaemondir}/*

%{_mandir}/man1/*
%{_mandir}/man7/*
%{_mandir}/man8/*


%files ldap
%defattr(-,root,root,0755)
                   %{_prefix}/%{_lib}/%{name}/authlib/authdaemond.ldap
%config(noreplace) /etc/openldap/schema/courier.schema
%config(noreplace) %{_sysconfdir}/%{name}/authldaprc


%files mysql
%defattr(-,root,root,0755)
        %{_prefix}/%{_lib}/%{name}/authlib/authdaemond.mysql
%config(noreplace) %{_sysconfdir}/%{name}/authmysqlrc


%files pgsql
%defattr(-,root,root,0755)
        %{_prefix}/%{_lib}/%{name}/authlib/authdaemond.pgsql
%config(noreplace) %{_sysconfdir}/%{name}/authpgsqlrc

%files authtest
%defattr(-,root,root,0755)
/usr/sbin/authtest

%changelog
* Thu May 03 2007 Nived Gopalan <nived at trustix dot org> 3.0.8-13tr
- Moved authtest to separate sub package, Bug #1811.

* Mon Nov 07 2005 Bipin S <bipin at comodo dot com> 3.0.8-12tr
- mkimapdcert now uses /etc/courier-imap/imapd.cnf. Fix Bug#1366.

* Wed Jul 06 2005 Hasher Jamaludeen <hasher at comodo dot com> 3.0.8-11tr
- Package needed authtest. Fix Bug #1035.

* Fri Apr 22 2005 Ajith Thampi <ajith at comodo dot com> 3.0.8-10tr
- Rebuilt with postgresql-8.0.2

* Tue Apr 19 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 3.0.8-9tr
- Changed init priority to 83 17

* Wed Dec  1 2004 Erlend Midttun <erlendbm at trustix dot org> 3.0.8-8tr
- Fix typo in imap initscript.

* Wed Nov 24 2004 Erlend Midttun <erlendbm at trustix dot org> 3.0.8-7tr
- Now have more sane names in initscript.

* Thu Nov 18 2004 Erlend Midttun <erlendbm at trustix dot org> 3.0.8-6tr
- Now even use Maildir.

* Tue Nov  9 2004 Oystein Viggen <oysteivi at trustix dot com> 3.0.8-5tr
- Rebuild with shared openssl

* Tue Nov  9 2004 Erlend Midttun <erlendbm at trustix dot org> 3.0.8-2tr
- Now own almostauthdaemondir as well.

* Sun Sep 19 2004 Erlend Midttun <erlendbm at trustix dot org> 3.0.8-1tr
- New upstream.

* Fri Aug 27 2004 Erlend Midttun <erlendbm at trustix dot org> 2.2.1-6tr
- Now only force stop if we are totally uninstalling the package.

* Tue Aug 24 2004 Oystein Viggen <oysteivi at trustix dot com> 2.2.1-5tr
- Fix format string vulnerability in debug.c (CAN-2004-0777)

* Mon Feb  2 2004 Chr. Toldnes <christht at trustix dot org> 2.2.1-2tr
- Fixed bug in %post

* Mon Dec 15 2003 Erlend Midttun <erlendbm at trustix dot org> 2.2.1-1tr
- New upstream.

* Wed Nov 19 2003 Erlend Midttun <erlendbm at trustix dot com> 2.2.0-1tr
- New upstream.
- Major cleanup.

* Wed Aug 20 2003 Gerald Dachs <gda at trustix dot org> 2.1.1-1gd
- New upstream version

* Wed Jun 25 2003 Frode Ramsvik <froder at trustix dot com> 1.7.1-11tr
- Default location for SSL-certificates is now /etc/ssl/certs

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 1.7.1-10tr
- Big rebuild

* Fri Jun 13 2003 Chr. Toldnes <christht at trustix dot com> 1.7.1-9ct
- Make silent about perl locale issue during install :)

* Fri Jun 13 2003 Chr. Toldnes <christht at trustix dot com> 1.7.1-8ct
- the simap and pop3 scripts was swapped during install.

* Thu Jun 12 2003 Chr. Toldnes <christht at trustix dot com> 1.7.1-7ct
- Added status function in initscritps
- Added check for services is already running

* Thu Jun 12 2003 Chr. Toldnes <christht at trustix dot com> 1.7.1-6ct
- new initscript layout. one script for each service.
- separate sources for config files.
- user makes ssl certs
- ssl cert generation works

* Fri Jun  6 2003 Gerald Dachs <gda at trustix dot org> 1.7.1-5gd
- removed usage of /etc/sysconfig/rc from initscript
- activated start of the services

* Mon May 26 2003 Erlend Midttun <erlendbm at trustix dot com> 1.7.1-4em
- fileutils, textutils, sh-utils -> coreutils

* Mon May 12 2003 Erlend Midttun <erlendbm at trustix dot com> 1.7.1-3em
- Now use /usr/lib instead of /usr/libexec
- Now use /var/spool/authdaemon/courier-imap instead of /var/auth...
- Now use /var/spool/courier instead of /var/tls...
- %ghost the generated config files.
- Use PAM only by default.

* Thu Mar 27 2003 Erlend Midttun <erlendbm at trustix dot com> 1.7.1-2em
- enhanced kenr's patch to enable build both against Berkeley DB 4.0 and 4.1

* Wed Mar 26 2003 Erlend Midttun <erlendbm at trustix dot com> 1.7.1-1em
- kenr made a patch to use Berkeley DB 4.1

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 1.6.2-7em
- Rebuilt against glibc 2.3.2.

* Thu Mar 20 2003 Erlend Midttun <erlendbm at trustix dot com> 1.6.2-6em
- rebuilt against PostgreSQL 7.3.2.

* Fri Jan 31 2003 Erlend Midttun <erlendbm at trustix dot com> 1.6.2-5em
- rebuilt against openssl 0.9.7.

* Wed Jan 29 2003 Goetz Bock <bock at trustix dot org> 1.6.2-4bg
- fixed typo in courier.initd to make stop call stop() not start()

* Mon Jan 27 2003 Erlend Midttun <erlendbm at trustix dot com> 1.6.2-3em
- Now requires imapd-pam package rather than provide the files.

* Sat Jan 18 2003 Gerald Dachs <gda at trustix dot org> 1.6.2-2gd
- rebuilt against openssl 0.9.7-1gd

* Wed Jan 15 2003 Goetz Bock <bock at trustix dot org> 1.6.2-1bg
- new upstream: 1.6.2
- rewrote SPEC file
- rewrote /etc/init.d/courier-imap

* Sun Sep 22 2002 Gerald Dachs <gda at trustix dot org> 1.5.2-3gd
- Rebuild against openldap 2.1.3

* Tue Sep 10 2002 Erlend Midttun <erlendbm at trustix dot com> 1.5.2-2em
- Fixed startup script.

* Tue Aug 20 2002 Gerald Dachs <gda at trustix dot org> 1.5.2-1gd
- .spec file based on original courier .spec file
